/****
 *
 * Exemplo: Funes de Disperso Prontas: Funo de Disperso
 *          FNV
 *
 * Seo: B.4
 *
 * Descrio: Implementao da funo de disperso FNV
 *
 ****/

#include <stdio.h>

/****
 *
 * DispersaoFNV(): Implementao da funo de disperso FNV
 *
 * Parmetros:
 *      chave (entrada) - a chave cujo valor de disperso
 *                        ser calculado
 *
 * Retorno: O valor de disperso calculado
 *
 * Observao: Esta funo no testa se o ponteiro que
 *             representa o string  NULL (como deveria)
 *
 ****/
unsigned int DispersaoFNV(const char *chave)
{
   unsigned int dispersao = 2166136261;

   while (*chave)
      dispersao = (dispersao*16777619) ^ *chave++;

   return dispersao;
}

/****
 *
 * main(): Testa a funo DispersaoFNV()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main()
{
   printf( "\n   >>>> Usando Dispersao FNV <<<<\n");
   printf( "\n>>> Dispersao de \"bola\" = %u",
           DispersaoFNV("bola") );
   printf( "\n>>> Dispersao de \"loba\" = %u\n",
           DispersaoFNV("loba") );

   return 0;
}

/****************** Resultado do Programa *****************

   >>>> Usando Dispersao FNV <<<<

>>> Dispersao de "bola" = 1711168029
>>> Dispersao de "loba" = 472896945

**********************************************************/
