#include <stdio.h>
#include <limits.h>

void RepresentacaoBinaria(int numero)
{
   int           i, bit, numeroDeBits;
   unsigned int  mascara; /* A mscara deve ser unsigned */

       /* Cada byte contm um nmero de bits igual a CHAR_BIT */
   numeroDeBits  = CHAR_BIT*sizeof(int);

       /* Coloca 1 na posio mais  esquerda da  */
       /* mscara. Todos os outros bits tero 0s. */
   mascara = 0x1 << (numeroDeBits - 1);

     /* Exibe cada bit a partir da esquerda */
   for (i = 1; i <= numeroDeBits; i++) {
      bit = (numero & mascara) ? 1 : 0;

         /* Apresenta um bit na tela */
      printf("%d", bit);

         /* Separa sequncias de bytes com espaos em branco */
         /* para melhor visualizao da representao        */
      if (i % CHAR_BIT == 0)
         printf("  ");

         /* Move bit com valor 1 da mscara */
         /* uma posio para a direita      */
      mascara >>= 1;
   }
}

/* Questo 29 - Cap. 7 */

int main(void)
{
   int x = 1, y = 1, z = 1, mascara, n;

   for (n = 1; n <= CHAR_BIT; ++n) {
      printf("\n\nRepresentacao Binaria de n = %d\n", n);
      RepresentacaoBinaria(n);

      mascara = 1 << n;

      printf("\n\nRepresentacao Binaria de mascara = %d\n", mascara);
      RepresentacaoBinaria(mascara);

      x |= mascara;

      printf("\n\nRepresentacao Binaria de x= %d\n", x);
      RepresentacaoBinaria(x);
   }

   printf("\n\n------------------------------------------------");

   for (n = 1; n <= CHAR_BIT; ++n) {
      printf("\n\nRepresentacao Binaria de n = %d\n", n);
      RepresentacaoBinaria(n);

      mascara = 1 << n;

      printf("\n\nRepresentacao Binaria de mascara = %d\n", mascara);
      RepresentacaoBinaria(mascara);

      y &= ~mascara;

      printf("\n\nRepresentacao Binaria de y = %d\n", y);
      RepresentacaoBinaria(y);
   }

   printf("\n\n------------------------------------------------");

   for (n = 1; n <= CHAR_BIT; ++n) {
      printf("\n\nRepresentacao Binaria de n = %d\n", n);
      RepresentacaoBinaria(n);

      mascara = 1 << n;

      printf("\n\nRepresentacao Binaria de mascara = %d\n", mascara);
      RepresentacaoBinaria(mascara);

      z ^= mascara;

      printf("\n\nRepresentacao Binaria de z= %d\n", z);
      RepresentacaoBinaria(z);
   }

   return 0;
}

/****************************************************************

Representacao Binaria de n = 1
00000000  00000000  00000000  00000001

Representacao Binaria de mascara = 2
00000000  00000000  00000000  00000010

Representacao Binaria de x= 3
00000000  00000000  00000000  00000011

Representacao Binaria de n = 2
00000000  00000000  00000000  00000010

Representacao Binaria de mascara = 4
00000000  00000000  00000000  00000100

Representacao Binaria de x= 7
00000000  00000000  00000000  00000111

Representacao Binaria de n = 3
00000000  00000000  00000000  00000011

Representacao Binaria de mascara = 8
00000000  00000000  00000000  00001000

Representacao Binaria de x= 15
00000000  00000000  00000000  00001111

Representacao Binaria de n = 4
00000000  00000000  00000000  00000100

Representacao Binaria de mascara = 16
00000000  00000000  00000000  00010000

Representacao Binaria de x= 31
00000000  00000000  00000000  00011111

Representacao Binaria de n = 5
00000000  00000000  00000000  00000101

Representacao Binaria de mascara = 32
00000000  00000000  00000000  00100000

Representacao Binaria de x= 63
00000000  00000000  00000000  00111111

Representacao Binaria de n = 6
00000000  00000000  00000000  00000110

Representacao Binaria de mascara = 64
00000000  00000000  00000000  01000000

Representacao Binaria de x= 127
00000000  00000000  00000000  01111111

Representacao Binaria de n = 7
00000000  00000000  00000000  00000111

Representacao Binaria de mascara = 128
00000000  00000000  00000000  10000000

Representacao Binaria de x= 255
00000000  00000000  00000000  11111111

Representacao Binaria de n = 8
00000000  00000000  00000000  00001000

Representacao Binaria de mascara = 256
00000000  00000000  00000001  00000000

Representacao Binaria de x= 511
00000000  00000000  00000001  11111111

------------------------------------------------

Representacao Binaria de n = 1
00000000  00000000  00000000  00000001

Representacao Binaria de mascara = 2
00000000  00000000  00000000  00000010

Representacao Binaria de y = 1
00000000  00000000  00000000  00000001

Representacao Binaria de n = 2
00000000  00000000  00000000  00000010

Representacao Binaria de mascara = 4
00000000  00000000  00000000  00000100

Representacao Binaria de y = 1
00000000  00000000  00000000  00000001

Representacao Binaria de n = 3
00000000  00000000  00000000  00000011

Representacao Binaria de mascara = 8
00000000  00000000  00000000  00001000

Representacao Binaria de y = 1
00000000  00000000  00000000  00000001

Representacao Binaria de n = 4
00000000  00000000  00000000  00000100

Representacao Binaria de mascara = 16
00000000  00000000  00000000  00010000

Representacao Binaria de y = 1
00000000  00000000  00000000  00000001

Representacao Binaria de n = 5
00000000  00000000  00000000  00000101

Representacao Binaria de mascara = 32
00000000  00000000  00000000  00100000

Representacao Binaria de y = 1
00000000  00000000  00000000  00000001

Representacao Binaria de n = 6
00000000  00000000  00000000  00000110

Representacao Binaria de mascara = 64
00000000  00000000  00000000  01000000

Representacao Binaria de y = 1
00000000  00000000  00000000  00000001

Representacao Binaria de n = 7
00000000  00000000  00000000  00000111

Representacao Binaria de mascara = 128
00000000  00000000  00000000  10000000

Representacao Binaria de y = 1
00000000  00000000  00000000  00000001

Representacao Binaria de n = 8
00000000  00000000  00000000  00001000

Representacao Binaria de mascara = 256
00000000  00000000  00000001  00000000

Representacao Binaria de y = 1
00000000  00000000  00000000  00000001

------------------------------------------------

Representacao Binaria de n = 1
00000000  00000000  00000000  00000001

Representacao Binaria de mascara = 2
00000000  00000000  00000000  00000010

Representacao Binaria de z= 3
00000000  00000000  00000000  00000011


Representacao Binaria de n = 2
00000000  00000000  00000000  00000010

Representacao Binaria de mascara = 4
00000000  00000000  00000000  00000100

Representacao Binaria de z= 7
00000000  00000000  00000000  00000111


Representacao Binaria de n = 3
00000000  00000000  00000000  00000011

Representacao Binaria de mascara = 8
00000000  00000000  00000000  00001000

Representacao Binaria de z= 15
00000000  00000000  00000000  00001111


Representacao Binaria de n = 4
00000000  00000000  00000000  00000100

Representacao Binaria de mascara = 16
00000000  00000000  00000000  00010000

Representacao Binaria de z= 31
00000000  00000000  00000000  00011111


Representacao Binaria de n = 5
00000000  00000000  00000000  00000101

Representacao Binaria de mascara = 32
00000000  00000000  00000000  00100000

Representacao Binaria de z= 63
00000000  00000000  00000000  00111111


Representacao Binaria de n = 6
00000000  00000000  00000000  00000110

Representacao Binaria de mascara = 64
00000000  00000000  00000000  01000000

Representacao Binaria de z= 127
00000000  00000000  00000000  01111111


Representacao Binaria de n = 7
00000000  00000000  00000000  00000111

Representacao Binaria de mascara = 128
00000000  00000000  00000000  10000000

Representacao Binaria de z= 255
00000000  00000000  00000000  11111111


Representacao Binaria de n = 8
00000000  00000000  00000000  00001000

Representacao Binaria de mascara = 256
00000000  00000000  00000001  00000000

Representacao Binaria de z= 511
00000000  00000000  00000001  11111111

*****************************************************************/
