#include <stdio.h>
#include <limits.h>

void RepresentacaoBinaria(int numero)
{
   int           i, bit, numeroDeBits;
   unsigned int  mascara; /* A máscara deve ser unsigned */

       /* Cada byte contém um número de bits igual a CHAR_BIT */
   numeroDeBits  = CHAR_BIT*sizeof(int);

       /* Coloca 1 na posição mais à esquerda da  */
       /* máscara. Todos os outros bits terão 0s. */
   mascara = 0x1 << (numeroDeBits - 1);

     /* Exibe cada bit a partir da esquerda */
   for (i = 1; i <= numeroDeBits; i++) {
      bit = (numero & mascara) ? 1 : 0;

         /* Apresenta um bit na tela */
      printf("%d", bit);

         /* Separa sequências de bytes com espaços em branco */
         /* para melhor visualização da representação        */
      if (i % CHAR_BIT == 0)
         printf("  ");

         /* Move bit com valor 1 da máscara */
         /* uma posição para a direita      */
      mascara >>= 1;
   }
}

/* Questão 32 - Cap. 7 */

int main(void)
{
   int x = ~9430;

   printf("Representacao Binaria de %d\n", x);
   RepresentacaoBinaria(x);

   putchar('\n');

   return 0;
}
/****************************************************************

Representacao Binaria de -9431
11111111  11111111  11011011  00101001

‭FFFFFFFFFFFFDB29‬

*****************************************************************/
