#include <stdio.h>
#include <limits.h>

void RepresentacaoBinaria(int numero)
{
   int           i, bit, numeroDeBits;
   unsigned int  mascara; /* A máscara deve ser unsigned */

       /* Cada byte contém um número de bits igual a CHAR_BIT */
   numeroDeBits  = CHAR_BIT*sizeof(int);

       /* Coloca 1 na posição mais à esquerda da  */
       /* máscara. Todos os outros bits terão 0s. */
   mascara = 0x1 << (numeroDeBits - 1);

     /* Exibe cada bit a partir da esquerda */
   for (i = 1; i <= numeroDeBits; i++) {
      bit = (numero & mascara) ? 1 : 0;

         /* Apresenta um bit na tela */
      printf("%d", bit);

         /* Separa sequências de bytes com espaços em branco */
         /* para melhor visualização da representação        */
      if (i % CHAR_BIT == 0)
         printf("  ");

         /* Move bit com valor 1 da máscara */
         /* uma posição para a direita      */
      mascara >>= 1;
   }
}

unsigned Misterio1(unsigned a, unsigned b)
{
   unsigned x = 0,
            y = 0,
            z = ~0;

   for (z = ~0; z; z >>= 1) {
      y <<= 1;
      y |= (a^b^x) & 1;
      x = ((a | b) & x | a & b) & 1;
      a >>= 1;
      b >>= 1;
   }

   for (z = ~0, x = ~z; z; z >>= 1) {
      x <<= 1;
      x |= y & 1;
      y >>= 1;
   }

   return x;
}

unsigned Misterio2(unsigned a, unsigned b)
{
   unsigned resultado;

   for (resultado = 0; a; b <<= 1, a >>= 1)
      if (a&1)
         resultado = Misterio1(resultado, b);

   return resultado;
}

/* Questão 43 - Cap. 7 */

int main(void)
{
   int x = 5, y = 3, z;

   printf("\n*** Misterio1 ***\n");
   z  = Misterio1(x, y);
   printf("\nx = %d\t y = %d\t z = %d\n", x, y, z);

   printf("\n*** Misterio2 ***\n");
   z  = Misterio2(x, y);
   printf("\nx = %d\t y = %d\t z = %d", x, y, z);

//   RepresentacaoBinaria(x);

   putchar('\n');

   return 0;
}
/****************************************************************

*** Misterio1 ***

x = 5    y = 3   z = 8

*** Misterio2 ***

x = 5    y = 3   z = 15

*****************************************************************/
