#ifndef _ARVORE_RN_H_
#define _ARVORE_RN_H_

/* Baseado em cdigo desenvolvido por Julienne Walker */

#include "Registros.h" /* Interface do mdulo Registros */
#include <stdio.h>     /* FILE */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tChave[TAM_CEP + 1];

   /* Tipo do contedo de cada n */
typedef struct {
           tChave chave; /* CEP */
           int    valor; /* ndice do CEP no arquivo */
        } tConteudo;

typedef enum {ESQUERDA = 0, DIREITA = 1} tDirecao;

typedef enum {PRETO = 0, VERMELHO = 1} tCor;

typedef struct noRN {
           tCor         cor; /* Indica se a cor do n */
           tConteudo    conteudo; /* Contedo do n */
           struct noRN *filho[2]; /* Os filho do n */
        } tNoRN;

typedef struct {
           tNoRN *raiz; /* Raiz da rvore */
           int    nNos; /* Nmero de ns da rvore */
        } tArvoreRN;

typedef void (*tOperacao) (tConteudo, FILE*);

typedef int (*tCompara) (const void *, const void *);

/************************* Aluses ************************/

extern tArvoreRN *CriaArvoreRN(void);
extern int EstaVaziaArvoreRN(tArvoreRN *arvore);
extern void DestroiArvoreRN( tArvoreRN *arvore );
extern tConteudo *BuscaRN(tArvoreRN *arvore, tChave chave);
extern int InsereRN( tArvoreRN *arvore, const tConteudo *conteudo );
extern int RemoveRN(tArvoreRN *arvore, tChave chave);
extern int AlteraConteudoArvoreRN( tArvoreRN *arvore, tChave chave,
                                   tConteudo *conteudo );
extern int NumeroNosRN(tArvoreRN *arvore);
extern void CaminhamentoInfixo( tNoRN *raiz, tOperacao op, FILE *stream );
extern int ProfundidadeRN(tNoRN *raiz);
extern tConteudo *MenorChave(tArvoreRN *arvore);
extern tConteudo *MaiorChave(tArvoreRN *arvore);
extern int AvaliaArvoreRubroNegra(tArvoreRN *arvore, tCompara compara);

#endif
