/****
 *
 * Exemplo: Ocorrncias de Erros em Processamento de Arquivos
 *
 * Seo: 2.4
 *
 ****/

#include <stdio.h>

int main(void)
{
   FILE *stream;
   char  str[] = "\nEste e' um arquivo de texto\n";
   int   c;

      /* Tenta criar um  arquivo para escrita e leitura */
   stream = fopen("Teste.txt", "w+");

      /* Verifica se arquivo foi aberto */
   if (!stream) {
      printf("\nArquivo nao pode ser aberto\n");
      return 1; /* Abertura de arquivo falhou */
   }

      /* Escreve o contedo do string   */
      /* armazenado em str[] no arquivo */
   fprintf(stream, "%s", str);

      /* Verifica se ocorreu erro de escrita */
   if (ferror(stream)) {
      printf("\n>>> Ocorreu um erro de escrita no arquivo"
             "\n>>> indicado por ferror()\n");
   }

      /* Volta ao incio do arquivo para l-lo em */
      /* seguida. Se ocorreu erro de escrita,     */
      /* rewind() remove o indicativo de erro     */
   rewind(stream);

   printf("\n\t>>> Conteudo do arquivo <<<\n");

      /* L contedo do arquivo. O lao encerra quando ocorrer */
      /* erro ou tentativa de leitura alm do final do arquivo */
   while (1) {
      c = fgetc(stream); /* L um caractere no stream */

         /* Se ocorreu erro ou tentativa de leitura alm */
         /* do final do arquivo, encerra o lao          */
      if (feof(stream) || ferror(stream)) {
         break;
      }

         /* Se no ocorreu erro nem tentativa deleitura alm do */
         /* final do arquivo, exibe o caractere lido na tela    */
      putchar(c);
   }

      /* Verifica se a funo feof() indica que houve  */
      /* tentativa de leitura alm do final do arquivo */
   if (feof(stream)) {
      printf("\n>>> Tentativa de leitura alem do final"
             "\n>>> do arquivo indicada por feof()\n");
   }

      /* Verifica se o ltimo caractere */
      /* retornado por fgetc() foi EOF  */
   if (c == EOF) {
      printf("\n>>> A funcao fgetc() retornou EOF\n");
   }

      /* Verifica se ferror() indica ocorrncia de erro */
   if (ferror(stream)) {
      printf("\n>>> Ocorreu um erro de leitura no arquivo"
             "\n>>> indicado por ferror()\n");
   }

   fclose(stream); /* Fecha o arquivo */

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Conteudo do arquivo <<<

Este e' um arquivo de texto

>>> Tentativa de leitura alem do final
>>> do arquivo indicada por feof()

>>> A funcao fgetc() retornou EOF

***********************************************************/
