#ifndef _Tabela_H_
#define _Tabela_H_

#include "Registros.h" /* Interface do mdulo Registros */

/****************** Definies de Tipos *******************/

typedef char tCEP[TAM_CEP + 1]; /* Tipo de chave */

typedef struct {
           tCEP chave; /* CEP */
           int  valor; /* ndice do CEP no arquivo */
        } tCEP_Ind;

   /* Tipo de n e tipo de ponteiro para n */
   /* de uma lista simplesmente encadeada   */
typedef struct rotNoLSE {
           tCEP_Ind         conteudo;
           struct rotNoLSE *proximo;
        } tNoListaSE, *tListaSE;

/************************* Aluses ************************/

extern void IniciaListaSE(tListaSE *lista);
extern int ComprimentoListaSE(tListaSE lista);
extern void InsereLSE( tListaSE *lista, const tCEP_Ind *conteudo );
extern int RemoveLSE(tListaSE *lista, tCEP chave);
extern int EstaVaziaLSE(tListaSE lista);
extern tCEP_Ind *BuscaComTransposicaoLSE( tListaSE *lista, tCEP chave );
extern tCEP_Ind *BuscaComMovimentoLSE( tListaSE *lista, tCEP chave );
extern void DestroiListaSE(tListaSE *lista);
extern tCEP_Ind *ProximoListaSE(tListaSE lista);

#endif
