#ifndef _Lista_H_
#define _Lista_H_

#include "Registros.h" /* Interface deste mdulo */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tCEP[MAX_NOME + 1];

typedef struct {
           tCEP chave;     /* Nome abreviado */
           int    indiceCEP; /* ndice do CEP no arquivo */
        } tCEP_Ind;

   /* Tipo de n e tipo de ponteiro para n de uma lista encadeada */
typedef struct rotNoSE {
           tCEP_Ind       conteudo;
           struct rotNoSE *proximo;
        } tNoSE, *tListaSE;

/************************* Aluses ************************/

extern void IniciaListaSE(tListaSE *lista);
extern int ComprimentoListaSE(tListaSE lista);
extern void InsereNoLSE( tListaSE *lista,
                         const tCEP_Ind *conteudo );
extern int RemoveNoLSE(tListaSE *lista, int indice);
extern int EstaVaziaLSE(tListaSE lista);
extern tListaSE BuscaSecundariaLSE( tListaSE lista, tCEP chave );
extern tCEP_Ind *BuscaSequencialLSE( tListaSE lista, int chave );
extern int AlteraConteudoLSE( tListaSE lista, int indice,
                              const tCEP_Ind *conteudos );
extern void DestroiListaSE(tListaSE *lista);
extern tCEP_Ind *ProximoListaSE(tListaSE lista);

#endif
