#ifndef _Tabela_H_
#define _Tabela_H_

#include "Registros.h" /* Interface do mdulo Registros */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tCEP[TAM_CEP + 1];

typedef struct {
           tCEP chave; /* CEP */
           int  valor; /* ndice do CEP no arquivo */
        } tCEP_Ind;

   /* Tipo de n e tipo de ponteiro para n */
   /* de uma lista simplesmente encadeada   */
typedef struct rotNoSE {
           tCEP_Ind       conteudo;
           struct rotNoSE *proximo;
        } tNoSE, *tListaSE;

/************************* Aluses ************************/

extern void IniciaListaSE(tListaSE *lista);
extern int ComprimentoListaSE(tListaSE lista);
extern void InsereNoLSE( tListaSE *lista,
                         const tCEP_Ind *conteudo );
extern int RemoveNoLSE(tListaSE *lista, tCEP chave);
extern int EstaVaziaLSE(tListaSE lista);
extern tListaSE BuscaIntervaloLSE(tListaSE lista, tCEP chave1, tCEP chave2);
extern tCEP_Ind *BuscaSequencialLSE(tListaSE tabela, tCEP chaveProcurada);
extern int AlteraConteudoLSE( tListaSE lista, tCEP chave,
                              const tCEP_Ind *conteudos );
extern void DestroiListaSE(tListaSE *lista);
extern tCEP_Ind *ProximoListaSE(tListaSE lista);

#endif
