/****
 *
 * Arquivo ArvoreBusca.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/07/2016
 * ltima modificao: 22/07/2016
 *
 * Descrio: Interface do mdulo ArvoreBusca
 *
 ****/

#ifndef _ArvoreBusca_
#define _ArvoreBusca_

#include <stdio.h>     /* FILE */
#include "Registros.h" /* Interface do mdulo Registros */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tCEP[TAM_CEP + 1];

   /* Tipo do contedo de cada n */
typedef struct {
           tCEP chave; /* CEP */
           int  valor; /* ndice do CEP no arquivo */
        } tCEP_Ind;

   /* Tipo de n e tipo de ponteiro para n de uma rvore afunilada */
typedef struct rotNoABB {
           struct rotNoABB *esquerda;
           tCEP_Ind         conteudo;
           struct rotNoABB *direita;
        } tNoArvoreBB, *tArvoreBB;

typedef void (*tOperacao) (tCEP_Ind, FILE*);

/************************* Aluses ************************/

extern void IniciaArvoreBB(tArvoreBB *arvore);
extern int NumeroNosArvoreBB(tArvoreBB arvore);
extern int AlturaArvoreBB(tArvoreBB arvore);
extern tCEP_Ind *BuscaArvoreFunil(tArvoreBB *arvore, tCEP chave);
extern int InsereArvoreFunil(tArvoreBB *arvore, tCEP_Ind *conteudo);
extern int RemoveArvoreFunil(tArvoreBB *arvore, tCEP chave);
extern int AlteraConteudoArvoreFunil( tArvoreBB *arvore, tCEP chave,
                                      tCEP_Ind *conteudos );
extern void DestroiArvoreBB(tArvoreBB arvore);
extern void CaminhamentoInfixoBB(tArvoreBB arvore, tOperacao op, FILE *stream);
extern tCEP_Ind *MenorChaveArvoreBB(tArvoreBB p);
extern tCEP_Ind *MaiorChaveArvoreBB(tArvoreBB p);

#endif
