/****
 *
 * Arquivo ArvoreBusca.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/07/2016
 * ltima modificao: 22/07/2016
 *
 * Descrio: Interface do mdulo ArvoreBusca
 *
 ****/

#ifndef _ArvoreBusca_
#define _ArvoreBusca_

#include <stdio.h>     /* FILE */
#include "Registros.h" /* Interface do mdulo Registros */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tChave[TAM_CEP + 1];

   /* Tipo do contedo de cada n */
typedef struct {
           tChave chave; /* CEP */
           int    valor; /* ndice do CEP no arquivo */
        } tConteudo;

   /* Tipo de n e tipo de ponteiro */
   /* para n de uma rvore binria */
typedef struct no {
           struct no *esquerda;
           tConteudo  conteudo;
           struct no *direita;
        } tNo, *tArvoreFunil;

typedef void (*tOperacao) (tConteudo, FILE*);

/************************* Aluses ************************/

extern void IniciaArvoreFunil(tArvoreFunil *arvore);
extern int NumeroNosArvoreFunil(tArvoreFunil arvore);
extern int ProfundidadeArvoreFunil(tArvoreFunil arvore);
extern tConteudo *BuscaArvoreFunil(tArvoreFunil *arvore,
                                   tChave chave);
extern int InsereNoArvoreFunil( tArvoreFunil *arvore,
                                tConteudo *conteudo );
extern int RemoveNoArvoreFunil(tArvoreFunil *arvore, tChave chave);
extern int EstaVaziaLSE(tArvoreFunil arvore);
extern int AlteraConteudoArvoreFunil( tArvoreFunil *arvore,
                                      tChave chave,
                                      tConteudo *conteudos );
extern void DestroiArvoreBin(tArvoreFunil arvore);
extern void CaminhamentoInfixo( tArvoreFunil arvore, tOperacao op,
                                FILE *stream );
extern tConteudo *MenorChave(tArvoreFunil p);
extern tConteudo *MaiorChave(tArvoreFunil p);

#endif
