/****
 *
 * Arquivo: ASSEGURA.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 10/04/2013
 * ltima modificao: 10/04/2013
 *
 * Descrio: Define a macro ASSEGURA utilizada em
 *            tratamento de condies de exceo
 *
 ****/

   /* Previne incluso mltipla deste arquivo */
#ifndef _ASSEGURA_H_
#define _ASSEGURA_H_

/*********************** Includes *************************/

#include <stdio.h>   /* fprintf() */
#include <stdlib.h>  /* exit()    */

/************************* Macros *************************/

   /* Macro utilizada em tratamento */
   /* de condies de exceo       */
#define ASSEGURA(condicao, msg) if (!(condicao)) {\
                                   fprintf(stderr, "\n%s\n", msg);\
                                   exit(1); \
                                }

   /* As seguintes macros so usadas em conjunto com a macro  */
   /* ASSEGURA para imprimir mensagens de erro indicando o    */
   /* tipo de erro e em que funo do programa o erro ocorreu */
#define ERRO_SEEK(f) \
        "ERRO: tentando mover apontador de arquivo na funcao " #f
#define ERRO_OPEN(f) \
        "ERRO: Nao foi possivel abrir o arquivo na funcao " #f
#define ERRO_LE_NO(f) \
        "ERRO: Nao foi possivel ler um no' na funcao " #f
#define ERRO_FWRITE(f) \
        "ERRO: Nao foi possivel gravar arquivo na funcao " #f
#define ERRO_FREAD(f) \
        "ERRO: Nao foi possivel ler arquivo na funcao " #f

#endif
