/****
 *
 * Arquivo ArvoreMulti.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 20/04/2004
 * ltima modificao: 20/07/2008
 *
 * Descrio: Interface das funes que implementam operaes
 *            usando rvores de busca multidirecional
 *
 ****/

#ifndef _ArvoreMulti_H_  /* Previne incluso mltipla deste arquivo */
#define _ArvoreMulti_H_

/*********************** Includes *************************/

#include <stdio.h>     /* Tipo FILE */
#include "Registros.h" /* Interface do mdulo Registros */

/************ Definies de Tipos e Constantes ************/

   /* Tipo do par chave/ndice armazenado nos ns */
typedef struct  {
          tChave chave;  /* Chave do registro              */
          int    indice; /* Posio do registro no arquivo */
} tChaveIndice;

#define G  5

   /* Tipo de um n da rvore de busca multidirecional armazenada em arquivo */
typedef struct rotNoMulti {
           int                nFilhos; /* O nmero de filhos do n */
           tChaveIndice       chaves[G - 1]; /* array contendo chaves  */
                                             /* e ndices de registros */
           struct rotNoMulti *filhos[G]; /* array contendo as posies dos filhos */
                                         /* no arquivo que contm a rvore        */
        } tNoMulti, *tArvoreMulti;

   /* Tipo de n e de ponteiro para n de uma lista encadeada */
   /* contendo ndices de registros de chaves removidas       */
typedef struct noLista {
           int             indice;
           struct noLista *proximo;
        } tNoIndice, *tListaRemocoes;

/************************* Aluses ************************/

extern int BuscaMulti(tArvoreMulti arvore, tChave chave);
extern int InsereMulti( tArvoreMulti *arvore, tChaveIndice *chaveEIndice );
extern int RemoveChaveMulti(tArvoreMulti *arvore, tChave chave);
extern void CaminhamentoInfixoMulti(tArvoreMulti arvore, FILE *stream);
extern tChaveIndice *MenorChaveMulti(tArvoreMulti arvore);
extern tChaveIndice *MaiorChaveMulti(tArvoreMulti arvore);
extern int AlturaMulti(tArvoreMulti arvore);
extern int NumeroDeChavesMulti(tArvoreMulti arvore);
extern int NumeroDeNosMulti(tArvoreMulti arvore);

#endif

