/****
 *
 * Exemplo: Funo de disperso para chaves reais
 *
 * Seo: 7.2.2
 *
 * Descrio: Implementao de uma funo de disperso para chaves reais
 *
 ****/

#include <stdio.h> /* Entrada e sada               */
#include <math.h>  /* Operaes sobre nmeros reais */

/****
 *
 * DispersaoReal(): Calcula o valor de disperso de um nmero real
 *
 * Parmetros:
 *     *chave (entrada) - a chave
 *      tam (entrada) - tamanho da tabela de disperso
 *
 * Retorno: O valor de disperso calculado
 *
 ****/
unsigned DispersaoReal(double chave, int tam)
{
   unsigned precisao = 1000000;
   double   pInteira,
            pReal = modf(chave, &pInteira);

   return ((unsigned) pInteira + (unsigned) (pReal*precisao))%tam;
}

/****
 *
 * main(): Testa a funo DispersaoReal()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   double c = 2.54;
   int    tamTab = 113;

   printf( "\n>>> Valor de dispersao: %u\n", DispersaoReal(c, tamTab) );

   return 0;
}

/****************** Resultado do Programa *****************

>>> Valor de dispersao: 88

**********************************************************/
