/****
 *
 * Exemplo: Mtodos de Clculo de Disperso: Mtodo de XOR
 *
 * Seo: 7.2.3
 *
 * Descrio: Implementao de uma funo disperso
 *            usando o mtodo de XOR
 *
 ****/

#include <stdio.h>

/****
 *
 * DispersaoXOR(): Calcula o valor de disperso de um
 *                 string usando o mtodo de XOR
 *
 * Parmetros:
 *      chave (entrada) - o string
 *
 * Retorno: Nada
 *
 * Observao: Esta funo no testa se o ponteiro que
 *             representa o string  NULL (como deveria)
 *
 ****/
unsigned int DispersaoXOR(const char *chave)
{
   unsigned int dispersao = *chave;

   while (*chave)
       dispersao ^= *chave++;

   return dispersao;
}

/****
 *
 * main(): Testa a funo DispersaoXOR()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   printf( "\n>>> Dispersao de \"bola\" = %u",
           DispersaoXOR("bola") );

   printf( "\n>>> Dispersao de \"loba\" = %u\n",
           DispersaoXOR("loba") );

   return 0;
}

/****************** Resultado do Programa *****************

>>> Dispersao de "bola" = 98
>>> Dispersao de "loba" = 108

**********************************************************/
