/****
 *
 * Exemplo: Algoritmos de Clculo de Disperso: Mtodo Rotativo
 *
 * Seo: 7.2.3
 *
 * Descrio: Implementao de uma funo disperso
 *            usando o mtodo rotativo
 *
 ****/

#include <stdio.h>

/****
 *
 * DispersaoRotativa(): Calcula o valor de disperso de um
 *                      string usando o mtodo rotativo
 *
 * Parmetros:
 *      chave (entrada) - o string
 *
 * Retorno: Nada
 *
 * Observao: Esta funo no testa se o ponteiro que
 *             representa o string  NULL (como deveria)
 *
 ****/
unsigned int DispersaoRotativa(const char *chave)
{
   unsigned int dispersao = 0;

   while (*chave)
       dispersao = (dispersao << 4) ^
                   (dispersao >> 28) ^ (*chave++);

   return dispersao;
}

/****
 *
 * main(): Testa a funo DispersaoRotativa()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   printf( "\n>>> Dispersao de \"bola\" = %u",
           DispersaoRotativa("bola") );

   printf( "\n>>> Dispersao de \"loba\" = %u\n",
           DispersaoRotativa("loba") );

   return 0;
}

/****************** Resultado do Programa *****************

>>> Dispersao de "bola" = 412065
>>> Dispersao de "loba" = 436545

**********************************************************/
