/****
 *
 * Arquivo: Heap.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 06/10/2017
 * ltima modificao: 06/10/2017
 *
 * Descrio: Interface do mdulo Heap
 *
 ****/

#ifndef _Heap_H_
#define _Heap_H_

/****************** Definies de Tipos *******************/

   /* Tipo de n de um heap */
typedef int tNoHeap;

typedef struct {
           tNoHeap *itens; /* Array de elementos */
           int      capacidade; /* Quantos elementos o heap pode conter */
           int      nItens; /* Nmero de elementos do heap */
        } tHeap;

   /* Tipo de ponteiro para funo de comparao */
   /* que compara elementos do heap              */
typedef int (*tFCompara) (const void *, const void *);

/******************* Aluses de Funes *******************/

extern tHeap *IniciaHeap(tHeap *heap);
extern void DestroiHeap(tHeap *heap);
extern void InsereEmHeap( tHeap *heap, tNoHeap item, tFCompara Compara );
extern tNoHeap RemoveMinHeap(tHeap *heap, tFCompara Compara);
extern tNoHeap ObtemMinimoHeap(const tHeap *heap);
extern int HeapVazio(const tHeap *heap);
extern int TamanhoHeap(const tHeap *heap);
extern tHeap *ConstroiHeap(tNoHeap elementos[], int nElementos, tFCompara Compara);
extern void ExibeHeap(const tHeap *heap);

#endif
