/****
 *
 * Arquivo Tipos.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 06/10/2017
 * ltima modificao: 06/10/2017
 *
 * Descrio: Tipos utilizados pelo programa de simulao de
 *            lanchonete
 *
 ****/

#ifndef _Tipos_H_ /* Previne incluso mltipla deste arquivo */
#define _Tipos_H_

   /* Tipo que define um tipo de evento */
typedef enum {CHEGADA, SAIDA, PEDIDO} tTipoDeEvento;

   /* Tipo de varivel que contm informaes sobre um evento */
typedef struct {
           int           instante; /* Instante no qual o evento */
                                   /* ser processado           */
           int           nPessoas; /* Nmero de pessoas */
           tTipoDeEvento tipoDeEvento; /* Tipo do evento */
        } tEvento;

   /* Tipo de n de um heap */
typedef tEvento *tNoHeap;

typedef struct {
           tNoHeap *itens;   /* Array de elementos */
           int      capacidade; /* Quantos elementos  */
                                /* o heap pode conter */
           int      nItens;  /* Nmero de elementos do heap */
        } tHeap;

   /* Tipo de ponteiro para funo de comparao */
   /* que compara elementos do heap              */
typedef int (*tFCompara) (const void *, const void *);

   /* Tipo da varivel que conter   */
   /* informaes sobre a lanchonete */
typedef struct {
           int    nCadeiras;
           double faturamento;
        } tLanchonete;

#endif
