/****
 *
 * Arquivo Tipos.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 07/06/2016
 * ltima modificao: 15/05/2018
 *
 * Descrio: Tipos utilizados pelo programa de ordenao de
 *            arquivos
 *
 ****/

#ifndef _Tipos_H_ /* Previne incluso mltipla deste arquivo */
#define _Tipos_H_

#include "Macros.h"  /* Macros usadas pelo programa */

   /* Tipo da chave */
typedef long tChave;

   /* Tipo de varivel que contm informao */
   /* sobre um arquivo temporrio            */
typedef struct {
           char  nome[MAX_NOME_TMP]; /* Nome do arquivo */
           FILE *stream; /* Stream associado ao arquivo */
        } tArquivo;

typedef tArquivo tElemento;

   /* Tipo de n e tipo de ponteiro para n de uma fila   */
   /* encadeada de informaes sobre arquivos temporrios */
typedef  struct no {
            tElemento  conteudo;
            struct no *proximo;
         } tNo, *tListaSE;

   /* Tipo da fila que conter informaes */
   /* sobre arquivos temporrios           */
typedef struct {
           tNo *frente;
           tNo *fundo;
        } tFila;

   /* Tipo usado para armazenamento de */
   /* registros no arquivo binrio     */
typedef struct {
           long codigoAluno;
           long chave; /* Chave */
           char nomeIES[MAX_NOME_IES];
           char nomeCurso[MAX_NOME_CURSO];
           char sexoAluno;
           int  idadeAluno;
           char UFNascimento[MAX_UF_NASCIMENTO];
           int  anoIngresso;
         } tAluno, tRegistro;

#endif
