/****
 *
 * Arquivo Tipos.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 07/06/2016
 * ltima modificao: 15/05/2018
 *
 * Descrio: Tipos utilizados pelo programa de ordenao de arquivos
 *
 ****/

#ifndef _Tipos_H_ /* Previne incluso mltipla deste arquivo */
#define _Tipos_H_

#include "Macros.h"  /* Macros usadas pelo programa */

   /* Tipo da chave */
typedef long tChave;

   /* Tipo usado para armazenamento de */
   /* registros no arquivo binrio     */
typedef struct {
           long codigoAluno;
           long chave; /* Chave */
           char nomeIES[MAX_NOME_IES];
           char nomeCurso[MAX_NOME_CURSO];
           char sexoAluno;
           int  idadeAluno;
           char UFNascimento[MAX_UF_NASCIMENTO];
           int  anoIngresso;
         } tRegistroMEC;

   /* Tipo de varivel que contm informao sobre uma srie */
typedef struct {
           long          pos; /* Posio da prxima leitura */
           tRegistroMEC *buffer; /* Buffer associado  srie */
           int           nRegs; /* Nmero de registros que */
                                /* se encontram no buffer  */
           int           resto; /* Nmero de registros da srie */
                                /* que restam em arquivo        */
        } tSerieMS;

   /* Tipo de n de um heap */
typedef struct {
           tRegistroMEC *elemento; /* Ponteiro para um registro de uma srie */
           int           ir; /* ndice do registro em seu buffer */
           int           is; /* ndice da srie  qual o registro pertence */
        } tNoHeapIM_Arq;

   /* Tipo de um heap */
typedef struct {
           tNoHeapIM_Arq *itens;  /* Array de elementos do heap   */
           int            nItens; /* Nmero de elementos do array */
        } tHeapIM_Arq;

   /* Tipo de ponteiro para funo de comparao que compara registros */
typedef int (*tFCompara) (const void *, const void *);

#endif
